/**
 * Change layer images along with gamma changes
 *
 * @author mpdeimos
 * @website www.skinconsrtoium.com
 */

#include <lib/std.mi>
#include <lib/colormgr.mi>

global ColorMgr handler;
global List objects;

function onThemeChanged(String newtheme);

System.onScriptLoaded()
{
	handler = new ColorMgr;
	objects = new List;

	String param = getParam();
	if (!param)
		return;

	int i = 0;
	String id = "";
	while (true)
	{
		id = System.getToken(param, ";", i);
		if (id == "")
			break;
			
		GuiObject obj = getScriptGroup().findObject(id);
		if (obj)
		{
			objects.addItem(obj);
		}
				
		i++;
	}
}

handler.onColorThemeChanged(String newtheme)
{
	onThemeChanged(newtheme); //seems like string vcpu ins broken here
}

string onThemeChanged(String newtheme)
{
	String themeid = strmid(newtheme, 0, 2);

	for (int i = 0; i < objects.getNumItems(); i++)
	{
		GuiObject obj = objects.enumItem(i);
		String img = obj.getXmlParam("image");
		img = strleft(img, strlen(img)-2);
		obj.setXmlParam("image", img+themeid);

		if (obj.getClassName() == "Button")
		{
			img = obj.getXmlParam("hoverimage");
			img = strleft(img, strlen(img)-2);
			obj.setXmlParam("hoverimage", img+themeid);
			img = obj.getXmlParam("downimage");
			img = strleft(img, strlen(img)-2);
			obj.setXmlParam("downimage", img+themeid);
		}
	}
}
